{% extends 'members/base.html' %}

{% block title %}
    Friends
{% endblock %}

{% block content %}
    <div class="row ml-2 mr-2">
        <div class="col-lg-4">
            <div class="card">
                <div class="card-title text-center">New Friend</div>
                <div class="card-body">
                    <div class="form-group">
                        <label for="tb-new-friend-username">Username</label>
                        <input id="tb-new-friend-username" class="form-control" type="text">
                    </div>
                    <button id="btn-send-friend-request" type="submit" class="btn btn-primary">Send Request</button>

                </div>

            </div>
            <div class="border mt-2">
                <div id="request-list" class="card-title text-center">Friend Request</div>
                <div id="received-request"></div>
                <div id="sent-request"></div>

            </div>

        </div>
        <div id="friend-list" class="col-lg-8 friend-list">
        </div>
    </div>


    {% csrf_token %}
    <script>

        const getFriendList = () => {
            $('#friend-list').empty();
            $.ajax("{% url "members:friends" request.user.username %}").done(data => {
                console.log(data);
                if (data.friends) {
                    data.friends.forEach(friend => {
                        let card = document.createElement('div');
                        $(card).addClass('card mt-2 mb-2 mr-2 ml-2 float-left friend-card text-center');

                        let img = document.createElement('img');
                        $(img).addClass('card-img-top friend-card-img');
                        {% load static %}
                        $(img).attr('src', '{% static 'images/user-img.png' %}');


                        let cardbody = document.createElement('div');
                        $(cardbody).addClass('card-bod');


                        let cardTitle = document.createElement('h5');
                        $(cardTitle).addClass('card-title');
                        $(cardTitle).text(`${friend.username}(${friend.first_name} ${friend.last_name})`);
                        cardTitle.dataset.username = friend.username;
                        $(cardTitle).on('click', (event) => {
                            window.location.pathname = creatreUserProfileUrl(event.target.dataset.username) ;
                        });

                        let cardText = document.createElement('div');
                        $(cardText).addClass('card-text');
                        $(cardText).text(friend.status);

                        let actions = document.createElement('div');
                        $(actions).addClass('action-container');

                        let message = document.createElement('button');
                        $(message).addClass('btn btn-primary');
                        $(message).text('Message');

                        let delete_friend = document.createElement("div");
                        $(delete_friend).addClass('fas fa-trash-alt delete-friend');
                        delete_friend.dataset.username = friend.username;
                        {#=============================================================================================================#}
                        let delete_container = document.createElement('div');
                        $(delete_container).addClass('delete-container');
                        delete_container.dataset.username = friend.username;
                        $(delete_container).append(delete_friend);
                        $(delete_container).on('click', (event) => {
                            let friend_username = '';
                            if (event.target.tagName === 'path') {
                                friend_username = event.target.parentElement.parentElement.dataset.username;
                            }
                            if (event.target.tagName === 'svg') {
                                friend_username = event.target.parentElement.dataset.username;
                            }
                            if (event.target.tagName === 'div') {
                                friend_username = event.target.dataset.username;
                            }
                            if (confirm("Are You Sure?")) {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: 'POST',
                                    headers: {"X-CSRFToken": csrftoken},
                                    url: '{% url "members:friends" request.user.username %}',
                                    data: {
                                        action: 'delete_friend',
                                        username: '{{ request.user.username }}',
                                        friend_username: friend_username
                                    },
                                    success: (data, textStatus) => {
                                        getFriendList();
                                    }
                                })
                            }

                        });

                        {#$(actions).append(message);#}
                        $(actions).append(delete_container);


                        $(cardbody).append(cardTitle);
                        $(cardbody).append(cardText);
                        $(cardbody).append(actions);

                        $(card).append(img);
                        $(card).append(cardbody);
                        $('#friend-list').append(card);
                    });
                }
            });
        };

        const getFriendRequestList = () => {
            $('#sent-request').empty();
            $('#received-request').empty();
            $.ajax("{% url "members:friend_requests" request.user.username %}").done(data => {
                console.log(data);
                if (data.request_list) {
                    data.request_list.forEach(request => {

                        if (request.status !== 'Open') {
                            return;
                        }

                        let card = document.createElement('div');
                        $(card).addClass('border mt-2 mb-2 mr-2 ml-2 friend-request-card text-center ');

                        let img = document.createElement('img');
                        $(img).addClass(' friend-request-card-img');
                        {% load static %}
                        $(img).attr('src', '{% static 'images/user-img.png' %}');


                        let content = document.createElement('div');
                        $(content).addClass('content');


                        let cardText = document.createElement('div');
                        $(cardText).addClass('card-text ml-1');


                        $(content).append(cardText);
                        $(card).append(img);
                        $(card).append(content);

                        //sent request
                        if (request.sender && request.sender === '{{ request.user.username }}') {
                            $(cardText).html(`<p>${request.receiver} <span class="timestamp">(${formateDate(request.created_time)})</span><p>`);

                            let btn_delete = document.createElement('button');
                            $(btn_delete).addClass('btn btn-danger float-right');
                            $(btn_delete).text('DELETE');
                            btn_delete.dataset.id = request.id;
                            $(btn_delete).on('click', (event) => {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: "POST",
                                    url: '{% url 'members:friend_requests' request.user.username %}',
                                    headers: {"X-CSRFToken": csrftoken},
                                    data: {
                                        'action': 'delete',
                                        'request-id': event.target.dataset.id
                                    },
                                    success: (data, textStatus) => {
                                        console.log(textStatus, ' ', data);
                                        if (data.message && data.message === 'ok') {
                                            getFriendRequestList();
                                        }
                                    }
                                });
                            });

                            let action_container = document.createElement('div');
                            $(action_container).addClass('action-container');
                            $(action_container).append(btn_delete);

                            $(card).append(action_container);


                            $('#sent-request').append(card);
                        }

                        // received request
                        if (request.receiver && request.receiver === '{{ request.user.username }}') {

                            $(cardText).html(`<p>${request.sender} <span class="timestamp">(${formateDate(request.created_time)})</span><p>`);

                            let btn_reject = document.createElement('button');
                            $(btn_reject).addClass('btn btn-danger ml-1');
                            $(btn_reject).text('REJECT');
                            btn_reject.dataset.id = request.id;
                            $(btn_reject).on('click', (event) => {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: "POST",
                                    url: '{% url 'members:friend_requests' request.user.username %}',
                                    headers: {"X-CSRFToken": csrftoken},
                                    data: {
                                        'action': 'reject',
                                        'request-id': event.target.dataset.id
                                    },
                                    success: (data, textStatus) => {
                                        console.log(textStatus, ' ', data);
                                        if (data.message && data.message === 'ok') {
                                            getFriendRequestList();
                                            getFriendList();
                                        }
                                    }
                                });
                            });


                            let btn_accept = document.createElement('button');
                            $(btn_accept).addClass('btn btn-primary ');
                            $(btn_accept).text('ACCEPT');
                            btn_accept.dataset.id = request.id;
                            $(btn_accept).on('click', (event) => {
                                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                                $.ajax({
                                    method: "POST",
                                    url: '{% url 'members:friend_requests' request.user.username %}',
                                    headers: {"X-CSRFToken": csrftoken},
                                    data: {
                                        'action': 'accept',
                                        'request-id': event.target.dataset.id
                                    },
                                    success: (data, textStatus) => {
                                        console.log(textStatus, ' ', data);
                                        if (data.message && data.message === 'ok') {
                                            getFriendRequestList();
                                            getFriendList();
                                        }
                                    }
                                });
                            });


                            {#action-container#}
                            let action_container = document.createElement('div');
                            $(action_container).addClass('action-container');
                            $(action_container).append(btn_accept);
                            $(action_container).append(btn_reject);

                            $(card).append(action_container);

                            $('#received-request').append(card);
                        }
                    })
                }

            });
        };


        $(document).ready(() => {

            getFriendList();

            getFriendRequestList();


            $('#btn-send-friend-request').on('click', () => {
                let csrftoken = jQuery("[name=csrfmiddlewaretoken]").val();
                $.ajax({
                    method: "POST",
                    url: "{% url "members:friend_requests" request.user.username %}",
                    headers: {"X-CSRFToken": csrftoken},
                    data: {
                        action: 'create',
                        sender: '{{ request.user.username }}',
                        receiver: $('#tb-new-friend-username').val()
                    },
                    success: (data, textStatus) => {
                        console.log(textStatus, ' ', data);
                        if (data.message && data.message === 'ok') {
                            getFriendRequestList();
                        }
                    }
                });


            });
        });
    </script>

{% endblock %}